#' Greater Antillean Anolis lizard dataset
#'
#' A dataset containing the dated phylogeny and the log snout-to-vent length for
#' Greater Antillean Anolis lizard species,
#' taken from Mahler et al. 2013.
#'
#' @format A data frame with 53940 rows and 10 variables:
#' \describe{
#'   \item{phy}{Bayesian maximum clade credibility chronogram for Greater Antillean Anolis from Mahler et al. 2013}
#'   \item{svl}{Natural log-transformed species average snout-to-vent length}
#'   \item{ecomorph}{Ecomorph assignments for each of the species}
#' }
#' 
#' @references 
#' Mahler, D. Luke; Ingram, Travis; Revell, Liam J.; Losos, Jonathan B. (2013), Data from: Exceptional convergence on the macroevolutionary landscape in island lizard radiations, Dryad, Dataset, https://doi.org/10.5061/dryad.9g182
#' 
#' @source 
#' \doi{10.5061/dryad.9g182}
"lizards"